#ifndef LIBFDSOLVER_H
#define LIBFDSOLVER_H

#include <cudaPbsolver.h>

#include <time.h>

#include <profiler.h>

#include <string>
#include <cstdlib>
#include <cmath>
#include <cstdio>
#include <fstream>


using namespace std;

void fdsolver(double salt, int * __restrict__ idpos, double * __restrict__ dbcorrection, 
	double * __restrict__ even_divisor, double * __restrict__ odd_divisor, int * __restrict__ charge_index, 
	double * __restrict__ qval, double * __restrict__ even_phi, double * __restrict__ odd_phi,
	int number_dielectrics1, int number_dielectrics2, int number_charges1, int number_charges2, 
	double omega, int nx, int ny, int nz, double max_error, int max_iterations, string calculation_mode);

#endif
