#include <nonlinearlibdelphisolver.h>

#define PI 3.14159265

extern "C" void NlDelphiSolverModule( void** __restrict__  idpos_, void** __restrict__  db_, void** __restrict__  sf1_,
	    void**  __restrict__ sf2_,void** __restrict__  iqpos_, void** __restrict__  qval_,int* icount2a_, int* icount2b_,
	    int* icount1a_, int* icount1b_, double* spec_, void** __restrict__ phimap_, void** __restrict__  phimap1_,void** __restrict__  phimap2_,
	    void** __restrict__  phimap3_, void** __restrict__  ibndx_, void** __restrict__  ibndy_, void** __restrict__  ibndz_,
	    void** __restrict__  bndx1_, void** __restrict__  bndx2_, void**  __restrict__ bndx3_, void**  __restrict__ bndx4_,
	    void** __restrict__ gval_, int* ibctyp_, int* isolvarch, double* rionst, int* igrid_, double* scale_, int* nlit, 
	    double* res2, void** __restrict__  inout_ , bool* imanual_, int* nnit_, int* ival1a, int* ival1b, int* ival2a, int* ival2b,
        double* conc1, double* conc2, void** qmap1_, void** qmap2_, double* qfact_, double* epsout_, double* deblen_, double* relpar_)
{
    double deblen = *deblen_;
    double relpar = *relpar_;
    double epsout = *epsout_;
    double qfact = *qfact_;
    double spec = *spec_;
    int nnit = *nnit_;
    bool imanual = *imanual_;
    double scale = *scale_;
    int igrid = *igrid_;
    //int ibctyp = *ibctyp_;

    double salt = *rionst;  
    int * __restrict__ idpos = (int*)idpos_;
    double * __restrict__ dbcorrection = (double*)*db_;
    double * __restrict__ even_divisor = (double*)*sf1_;
    double * __restrict__ odd_divisor = (double*)*sf2_;
    int * __restrict__ charge_index  = (int*)*iqpos_;
    double * __restrict__ qval = (double*)*qval_;
    double * __restrict__ even_phi = (double*)*phimap1_;
    double * __restrict__ odd_phi = (double*)*phimap2_;
    double * __restrict__ phimap3 = (double*)*phimap3_;
    double * __restrict__ phimap = (double*)*phimap_;
    bool * __restrict__ inout = (bool*)*inout_;
    double * qmap1 = (double*)*qmap1_;
    double * qmap2 = (double*)*qmap2_;
    
    int number_dielectrics1 = *icount2a_;
    int number_dielectrics2 = *icount2b_;
    int number_charges1 = *icount1a_;
    int number_charges2 = *icount1b_;
    double omega;
    int max_iterations = *nlit;
    double max_error = *res2;

    int *ival = new int[2];
    int *ival2 = new int[2];
    double *conc = new double[2];
    ival[0] = *ival1a;
    ival[1] = *ival1b;
    ival2[0] = *ival2a;
    ival2[0] = *ival2b;
    conc[0] = *conc1;
    conc[1] = *conc2;

    int ii;

    for (ii=0; ii<igrid*igrid*igrid; ii++)
        phimap3[ii] = phimap[ii];

    for (ii=0; ii<number_dielectrics2; ii++)
    	idpos[ii]--;

    for (ii=0; ii<number_charges2; ii++)
	charge_index[ii]--;
    
    scale = 1.0/scale;
    
    spec = 2.0/(1.0+sqrt(1.0-spec));
    omega = spec;
    
    for (ii=0; ii<(igrid*igrid*igrid+1)/2; ii++)
    {
        even_divisor[ii]  = even_divisor[ii]*spec; 
        odd_divisor[ii]  = odd_divisor[ii]*spec;
    }

    for (ii=0; ii<number_charges2; ii++)
    {
    	qval[ii] = qval[ii]*spec;
    }

    for (ii=0; ii<6*number_dielectrics2; ii++)
    	dbcorrection[ii] = dbcorrection[ii]*spec;
    
    for (ii=0; ii<(igrid*igrid*igrid+1)/2; ii++)
    {
    	even_phi[ii] = phimap3[2*ii];
    	odd_phi[ii] = phimap3[2*ii+1];
    }
    
    string calculation_mode;
    if (*isolvarch==2)
    {
        calculation_mode = "cpu";
    }
    else if (*isolvarch==1)
    {
        calculation_mode = "gpu";
    }

    nlfdsolver(salt, idpos, dbcorrection, even_divisor, odd_divisor, charge_index, qval, even_phi, odd_phi,
	    number_dielectrics1, number_dielectrics2, number_charges1, number_charges2, omega, igrid, 
	    igrid, igrid, max_error, max_iterations, calculation_mode, inout, imanual, nnit, ival, ival2,
	    conc, qmap1, qmap2,qfact,epsout,deblen,scale,relpar);

    for (ii=0; ii<(igrid*igrid*igrid-1)/2; ii++)
    {
    	phimap[2*ii] = even_phi[ii];
    	phimap[2*ii+1] = odd_phi[ii];
    }

    return;
}

